require 'active_record'

include ActiveRecord::Tasks

root = File.expand_path '../../..', __FILE__

DatabaseTasks.tap do |t|
  Application.start(:mysql)

  t.env = Application.env.to_s
  t.database_configuration = Application["mysql.config"]
  t.root = root
end

namespace :eng24233 do
  namespace :migrate do
    namespace :id_to_crn do

      require 'activerecord-import'

      desc "Update organization id from string to crn"
      task :organization_id_crn do
        puts "Updating org id to crn"
        ActiveRecord::Base.transaction do
          update_query =
              "UPDATE user_group_role_binding_organizations,
                (Select ugrbo.id as id,
                        ugrbo.user_group_role_binding_id as ugrbid,
                        ugrbo.organization_crn as ocrn,
                        ugrb.customer_crn as ccrn
                from user_group_role_binding_organizations as ugrbo,  user_group_role_bindings as ugrb
                where ugrbo.organization_crn NOT LIKE 'crn:%:organization/%' and ugrbo.user_group_role_binding_id = ugrb.id) as nes
		          SET organization_crn = CONCAT('crn:', SUBSTRING_INDEX(SUBSTRING_INDEX(nes.ccrn, '/', 2), '/', -1), ':organization/', organization_crn)
		          WHERE user_group_role_binding_organizations.id = nes.id;"

          ActiveRecord::Base.connection.execute(update_query);
        end
      end

    end
  end
end