require 'active_record'

include ActiveRecord::Tasks

root = File.expand_path '../../..', __FILE__

DatabaseTasks.tap do |t|
  Application.start(:mysql)

  t.env = Application.env.to_s
  t.database_configuration = Application["mysql.config"]
  t.root = root
end

namespace :eng47251 do
  namespace :migrate do
    namespace :add_tmc_rd do
      require 'activerecord-import'
      require 'role_management/stores'
      require 'role_management/models'
      require 'role_management/stores/role_documents_directory'
      desc "Up for system defined role document for TMC"
      task :add_role_document_up do
        ActiveRecord::Base.transaction do
            RoleManagement::Stores::RoleDocument.find_or_create_by(
                name: "Tanzu Mission Control",
                customer_crn: "crn::tenant/0",
                created_by_crn: "crn::user/0",
                updated_by_crn: "crn::user/0",
                description: "Tanzu Mission Control Integration Role Document",
                system_defined: true
            )
        end
      end
      desc "Down for system defined role document for TMC"
      task :add_role_document_down do
        ActiveRecord::Base.transaction do
            rd = RoleManagement::Stores::RoleDocument.where(system_defined: true, name: "Tanzu Mission Control").first
            unless rd.nil?
                rd.destroy
            end
        end
      end
    end
  end
end
