# frozen_string_literal: true

namespace :stats do
  desc "publish usage stats for role management"
  task publish: :environment do
    require 'cht-lib-fabric/crns'
    logger = Application['logger']
    wavefront = Application['wavefront']
    directory = Application['role_management.stores.role_documents_directory']

    logger.info "Logging usage stats"
    stats = directory.stats_by_customer
    stats.each do |(name, stats)|
      stat_name = "role_management.#{name}.count"
      stats.each do |(customer_crn, val)|
        crn = ::Platform::CRNs::Tenant.from_s(customer_crn)
        logger.debug "#{stat_name}: #{crn.details} = #{val}"
        wavefront.gauge(stat_name, val, customer_id: crn.details)
      end
    end
    wavefront.flush
  end
end